#include "math.h"
#include "libsx.h"
#include "sigfpe.h"

void quit(Widget w, void *data)
{
  exit(0);
}

#define PI (atan(1.0)*4)

struct mystruct {
   float kreis_x[628];
   float kreis_y[628];
   float pi;
   } strkt;

void init(void)
   {
   int i;
   strkt.pi=PI;
   for (i=0;i<(2.0*strkt.pi*100.0)+10;i++)
      {
      strkt.kreis_x[i]=sin(i/100.0);
      strkt.kreis_y[i]=cos(i/100.0);
      }
   }

void draw_stuff(Widget w, int width, int height, void *data)
{
  int i;
  ClearDrawArea();
  for (i=0;i<(2.0*strkt.pi*100.0);i++)
     {
     DrawLine(width/2,height/2,
              width/2+strkt.kreis_x[i]*width/2,
              height/2+strkt.kreis_y[i]*height/2);
     }
}

int main(int argc, char **argv)
{
  Widget w[2];

  init();

  sigfpe_[_EN_DIVZERO].abort=_ON;
  sigfpe_[_EN_DIVZERO].count=_OFF;
  sigfpe_[_EN_DIVZERO].trace=_OFF;
  handle_sigfpes(_TURN_OFF_HANDLER_ON_ERROR,_EN_DIVZERO,0,_ABORT_ON_ERROR,0);

  argc = OpenDisplay(argc, argv);
  if (argc == 0)                   /* woops, couldn't get started */
    exit(5);

  w[0] = MakeButton("Quit", quit, NULL);
  w[1] = MakeDrawArea(300,300, draw_stuff, NULL);

  SetWidgetPos(w[1], PLACE_UNDER, w[0], NO_CARE, NULL);

  ShowDisplay();
  GetStandardColors();

  MainLoop();   /* off we go! */
}

