#include "math.h"
#include "libsx.h"
#include "limits.h"
#include "sigfpe.h"

void quit(Widget w, void *data)
{
  exit(0);
}

#define PI (atan(1.0)*4)

void draw_stuff(Widget w, int width, int height, void *data)
{
  int i;
  float x1,y1;
  float x2,y2;
  ClearDrawArea();
  x1=width/2+sin(0)*width/2;
  y1=height/2+cos(0)*height/2; 
  for (i=1;i<=(4*2*PI*100.0);i++)
     {
     x2=width/2+(sin(i/100.0)*width/2)*100.0/(i-100);
     y2=height/2+(cos(i/100.0)*height/2)*100.0/(i-100);
     DrawLine(x1,y1,x2,y2);
     x1=x2;
     y1=y2;
     }
}

#include <sigfpe.h>

int main(int argc, char **argv)
{
  Widget w[2];

  sigfpe_[_EN_DIVZERO].abort=1;
  sigfpe_[_EN_DIVZERO].count=0;
  sigfpe_[_EN_DIVZERO].trace=0;
  handle_sigfpes(_DEBUG,_EN_DIVZERO,0,_ABORT_ON_ERROR,0);

  argc = OpenDisplay(argc, argv);
  if (argc == 0)                   /* woops, couldn't get started */
    exit(5);

  w[0] = MakeButton("Quit", quit, NULL);
  w[1] = MakeDrawArea(300,300, draw_stuff, NULL);

  SetWidgetPos(w[1], PLACE_UNDER, w[0], NO_CARE, NULL);

  ShowDisplay();
  GetStandardColors();

  MainLoop();   /* off we go! */
}

