#include "math.h"
#include "libsx.h"
#include "sigfpe.h"

void quit(Widget w, void *data)
{
  exit(0);
}

#define ROUNDS 10
#define PI (atan(1.0)*4)

float* wirbel_x;
float* wirbel_y;
float pi;

void init(void)
   {
   int i;
   pi=PI;
   wirbel_x=(float*)malloc(ROUNDS*2*314*sizeof(float));
   wirbel_y=(float*)malloc(ROUNDS*2*314*sizeof(float));
   for (i=0;i<=(ROUNDS*2*314);i++)
      {
      wirbel_x[i]=sin(i/100.0)*(2*pi*100.0)/i+1;
      wirbel_y[i]=cos(i/100.0)*(2*pi*100.0)/i+1;
      }
   }

void draw_stuff(Widget w, int width, int height, void *data)
{
  int i;
  ClearDrawArea();
  for (i=0;i<=(ROUNDS*2*314);i++)
     {
     DrawLine(width/2+wirbel_x[i  ]*width/2,height/2+wirbel_y[i  ]*height/2,
              width/2+wirbel_x[i+1]*width/2,height/2+wirbel_y[i+1]*height/2);
     }
}

int main(int argc, char **argv)
{
  Widget w[2];

  sigfpe_[_EN_DIVZERO].abort=_ON;
  sigfpe_[_EN_DIVZERO].count=_OFF;
  sigfpe_[_EN_DIVZERO].trace=_OFF;
  handle_sigfpes(_TURN_OFF_HANDLER_ON_ERROR,_EN_DIVZERO,0,_ABORT_ON_ERROR,0);

  init();

  argc = OpenDisplay(argc, argv);
  if (argc == 0)                   /* woops, couldn't get started */
    exit(5);

  w[0] = MakeButton("Quit", quit, NULL);
  w[1] = MakeDrawArea(300,300, draw_stuff, NULL);

  SetWidgetPos(w[1], PLACE_UNDER, w[0], NO_CARE, NULL);

  ShowDisplay();
  GetStandardColors();

  MainLoop();   /* off we go! */
}

